' Programm vergleicht Ausgangsspannung eines als Mikrofon eingesetzten Piezoschwingers
' mit der Spannung an einem Spannungsteiler. nach einem Doppelimpuls (Doppelklatschen) 
' wird PortB.3 für 1 Sekunde auf High geschaltet

' Compiler: BASCOM 2.0.7.5 Demo
'--------------------------------------------------------------------------------------

$regfile = "attiny13.dat"
$crystal = 1200000
$hwstack = 32
$swstack = 8
$framesize = 8

DIDR0 = &B00011111               ' alle Digitaleingänge deaktivieren

' Dies wäre die offizielle Bascom-Syntax für den Komparator:

' Config ACI = ON , COMPARE = ON
' Enable Interrupts
' Enable ACI


' so geht es mit direkter Register-Manipulation
ACSR.ACO = 1                     ' Output to IRQ ACO 
ACSR.ACIE = 1                    ' AC Interrupt Enable
SREG.7 = 1                       ' Interrupts enable
ACSR.ACD = 0                     ' AC Interrupt enable

' Alternative Komparatoreingänge wählt man so:
' ADCSRB.ACME = 1    ' Multiplexer enable
' ADMUX = 2          ' PinB.4 statt PinB.1
' ACSR.ACBG = 1      ' 1,1V Bandgap statt PinB.0 

Dim Aci_cntr As Byte
Dim Aci_cmp As Byte

On ACI on_aci                     ' Interrupt-Routine definieren

DDRB.3 = 1

Do

   If Aci_cntr > 0 then           ' erstes Klatschen, Interrupt(s) aufgetreten
      Waitms 100                   ' falls erstes Klatschen mehrere Interrupts erzeugte 
      Aci_cmp = Aci_cntr          ' Zahl der Interrupts zwischenspeichern  
      Waitms 300                  ' auf zweites klatschen warten 
      If Aci_cntr > Aci_cmp then  ' weitere Interrupts aufgetreten? 
	     PortB.3 = 1              ' Action! (LED an PortB.3 leuchtet kurz auf)
	     Wait 1
	     PortB.3 = 0
      End If
      Aci_cntr = 0
   End If
   Idle                           ' Powerdown schaltet leider den Komparator ab
Loop


on_aci:
    Incr Aci_cntr
Return


End
